// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package payment

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// PaymentClient is the client API for Payment service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type PaymentClient interface {
	// ListOrders lists orders based on the parameters in the request.
	ListOrders(ctx context.Context, in *ListOrdersRequest, opts ...grpc.CallOption) (*ListOrdersResponse, error)
	// CreateOrder creates a new order entity.
	CreateOrder(ctx context.Context, in *CreateOrderRequest, opts ...grpc.CallOption) (*Order, error)
	// GetOrder retrieves a singe order given its name.
	GetOrder(ctx context.Context, in *GetOrderRequest, opts ...grpc.CallOption) (*Order, error)
	// RefundOrderItems refunds a order items from a single order.
	RefundOrderItems(ctx context.Context, in *RefundOrderItemsRequest, opts ...grpc.CallOption) (*RefundOrderItemsResponse, error)
	// ListPaymentGateways lists payment gateways according to the request.
	ListPaymentGateways(ctx context.Context, in *ListPaymentGatewaysRequest, opts ...grpc.CallOption) (*ListPaymentGatewaysResponse, error)
	// CreatePaymentGateway creates a new payment gateway.
	CreatePaymentGateway(ctx context.Context, in *CreatePaymentGatewayRequest, opts ...grpc.CallOption) (*PaymentGateway, error)
	// GetPaymentGateway retrieves a payment gateway by its name.
	GetPaymentGateway(ctx context.Context, in *GetPaymentGatewayRequest, opts ...grpc.CallOption) (*PaymentGateway, error)
	// TriggerStateUpdate triggers a complete state update of the payment api. (Usually done lazily)
	TriggerStateUpdate(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*emptypb.Empty, error)
}

type paymentClient struct {
	cc grpc.ClientConnInterface
}

func NewPaymentClient(cc grpc.ClientConnInterface) PaymentClient {
	return &paymentClient{cc}
}

func (c *paymentClient) ListOrders(ctx context.Context, in *ListOrdersRequest, opts ...grpc.CallOption) (*ListOrdersResponse, error) {
	out := new(ListOrdersResponse)
	err := c.cc.Invoke(ctx, "/vseth.sip.payment.Payment/ListOrders", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *paymentClient) CreateOrder(ctx context.Context, in *CreateOrderRequest, opts ...grpc.CallOption) (*Order, error) {
	out := new(Order)
	err := c.cc.Invoke(ctx, "/vseth.sip.payment.Payment/CreateOrder", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *paymentClient) GetOrder(ctx context.Context, in *GetOrderRequest, opts ...grpc.CallOption) (*Order, error) {
	out := new(Order)
	err := c.cc.Invoke(ctx, "/vseth.sip.payment.Payment/GetOrder", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *paymentClient) RefundOrderItems(ctx context.Context, in *RefundOrderItemsRequest, opts ...grpc.CallOption) (*RefundOrderItemsResponse, error) {
	out := new(RefundOrderItemsResponse)
	err := c.cc.Invoke(ctx, "/vseth.sip.payment.Payment/RefundOrderItems", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *paymentClient) ListPaymentGateways(ctx context.Context, in *ListPaymentGatewaysRequest, opts ...grpc.CallOption) (*ListPaymentGatewaysResponse, error) {
	out := new(ListPaymentGatewaysResponse)
	err := c.cc.Invoke(ctx, "/vseth.sip.payment.Payment/ListPaymentGateways", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *paymentClient) CreatePaymentGateway(ctx context.Context, in *CreatePaymentGatewayRequest, opts ...grpc.CallOption) (*PaymentGateway, error) {
	out := new(PaymentGateway)
	err := c.cc.Invoke(ctx, "/vseth.sip.payment.Payment/CreatePaymentGateway", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *paymentClient) GetPaymentGateway(ctx context.Context, in *GetPaymentGatewayRequest, opts ...grpc.CallOption) (*PaymentGateway, error) {
	out := new(PaymentGateway)
	err := c.cc.Invoke(ctx, "/vseth.sip.payment.Payment/GetPaymentGateway", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *paymentClient) TriggerStateUpdate(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, "/vseth.sip.payment.Payment/TriggerStateUpdate", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// PaymentServer is the server API for Payment service.
// All implementations must embed UnimplementedPaymentServer
// for forward compatibility
type PaymentServer interface {
	// ListOrders lists orders based on the parameters in the request.
	ListOrders(context.Context, *ListOrdersRequest) (*ListOrdersResponse, error)
	// CreateOrder creates a new order entity.
	CreateOrder(context.Context, *CreateOrderRequest) (*Order, error)
	// GetOrder retrieves a singe order given its name.
	GetOrder(context.Context, *GetOrderRequest) (*Order, error)
	// RefundOrderItems refunds a order items from a single order.
	RefundOrderItems(context.Context, *RefundOrderItemsRequest) (*RefundOrderItemsResponse, error)
	// ListPaymentGateways lists payment gateways according to the request.
	ListPaymentGateways(context.Context, *ListPaymentGatewaysRequest) (*ListPaymentGatewaysResponse, error)
	// CreatePaymentGateway creates a new payment gateway.
	CreatePaymentGateway(context.Context, *CreatePaymentGatewayRequest) (*PaymentGateway, error)
	// GetPaymentGateway retrieves a payment gateway by its name.
	GetPaymentGateway(context.Context, *GetPaymentGatewayRequest) (*PaymentGateway, error)
	// TriggerStateUpdate triggers a complete state update of the payment api. (Usually done lazily)
	TriggerStateUpdate(context.Context, *emptypb.Empty) (*emptypb.Empty, error)
	mustEmbedUnimplementedPaymentServer()
}

// UnimplementedPaymentServer must be embedded to have forward compatible implementations.
type UnimplementedPaymentServer struct {
}

func (UnimplementedPaymentServer) ListOrders(context.Context, *ListOrdersRequest) (*ListOrdersResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListOrders not implemented")
}
func (UnimplementedPaymentServer) CreateOrder(context.Context, *CreateOrderRequest) (*Order, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateOrder not implemented")
}
func (UnimplementedPaymentServer) GetOrder(context.Context, *GetOrderRequest) (*Order, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetOrder not implemented")
}
func (UnimplementedPaymentServer) RefundOrderItems(context.Context, *RefundOrderItemsRequest) (*RefundOrderItemsResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method RefundOrderItems not implemented")
}
func (UnimplementedPaymentServer) ListPaymentGateways(context.Context, *ListPaymentGatewaysRequest) (*ListPaymentGatewaysResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ListPaymentGateways not implemented")
}
func (UnimplementedPaymentServer) CreatePaymentGateway(context.Context, *CreatePaymentGatewayRequest) (*PaymentGateway, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreatePaymentGateway not implemented")
}
func (UnimplementedPaymentServer) GetPaymentGateway(context.Context, *GetPaymentGatewayRequest) (*PaymentGateway, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetPaymentGateway not implemented")
}
func (UnimplementedPaymentServer) TriggerStateUpdate(context.Context, *emptypb.Empty) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method TriggerStateUpdate not implemented")
}
func (UnimplementedPaymentServer) mustEmbedUnimplementedPaymentServer() {}

// UnsafePaymentServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to PaymentServer will
// result in compilation errors.
type UnsafePaymentServer interface {
	mustEmbedUnimplementedPaymentServer()
}

func RegisterPaymentServer(s grpc.ServiceRegistrar, srv PaymentServer) {
	s.RegisterService(&Payment_ServiceDesc, srv)
}

func _Payment_ListOrders_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ListOrdersRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PaymentServer).ListOrders(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.payment.Payment/ListOrders",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PaymentServer).ListOrders(ctx, req.(*ListOrdersRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Payment_CreateOrder_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreateOrderRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PaymentServer).CreateOrder(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.payment.Payment/CreateOrder",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PaymentServer).CreateOrder(ctx, req.(*CreateOrderRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Payment_GetOrder_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetOrderRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PaymentServer).GetOrder(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.payment.Payment/GetOrder",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PaymentServer).GetOrder(ctx, req.(*GetOrderRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Payment_RefundOrderItems_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(RefundOrderItemsRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PaymentServer).RefundOrderItems(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.payment.Payment/RefundOrderItems",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PaymentServer).RefundOrderItems(ctx, req.(*RefundOrderItemsRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Payment_ListPaymentGateways_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ListPaymentGatewaysRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PaymentServer).ListPaymentGateways(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.payment.Payment/ListPaymentGateways",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PaymentServer).ListPaymentGateways(ctx, req.(*ListPaymentGatewaysRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Payment_CreatePaymentGateway_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreatePaymentGatewayRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PaymentServer).CreatePaymentGateway(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.payment.Payment/CreatePaymentGateway",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PaymentServer).CreatePaymentGateway(ctx, req.(*CreatePaymentGatewayRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Payment_GetPaymentGateway_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetPaymentGatewayRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PaymentServer).GetPaymentGateway(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.payment.Payment/GetPaymentGateway",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PaymentServer).GetPaymentGateway(ctx, req.(*GetPaymentGatewayRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Payment_TriggerStateUpdate_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(emptypb.Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(PaymentServer).TriggerStateUpdate(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.sip.payment.Payment/TriggerStateUpdate",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(PaymentServer).TriggerStateUpdate(ctx, req.(*emptypb.Empty))
	}
	return interceptor(ctx, in, info, handler)
}

// Payment_ServiceDesc is the grpc.ServiceDesc for Payment service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Payment_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "vseth.sip.payment.Payment",
	HandlerType: (*PaymentServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "ListOrders",
			Handler:    _Payment_ListOrders_Handler,
		},
		{
			MethodName: "CreateOrder",
			Handler:    _Payment_CreateOrder_Handler,
		},
		{
			MethodName: "GetOrder",
			Handler:    _Payment_GetOrder_Handler,
		},
		{
			MethodName: "RefundOrderItems",
			Handler:    _Payment_RefundOrderItems_Handler,
		},
		{
			MethodName: "ListPaymentGateways",
			Handler:    _Payment_ListPaymentGateways_Handler,
		},
		{
			MethodName: "CreatePaymentGateway",
			Handler:    _Payment_CreatePaymentGateway_Handler,
		},
		{
			MethodName: "GetPaymentGateway",
			Handler:    _Payment_GetPaymentGateway_Handler,
		},
		{
			MethodName: "TriggerStateUpdate",
			Handler:    _Payment_TriggerStateUpdate_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "vseth/sip/payment/payment.proto",
}
